#!/usr/bin/env python
# -*- coding: utf-8 -*-
"""wish no bug"""

import time
import sys
import os
import pandas as pd
from sklearn import preprocessing
from sklearn.linear_model import LogisticRegression
from sklearn import cross_validation
from sklearn.metrics import classification_report
from sklearn import neighbors
from sklearn import svm
from sklearn import lda



print os.getcwd()
data_0 = pd.read_csv('bank-additional.csv', sep=';')
# 数据清洗
data_0 = data_0.drop('duration',axis = 1)
num_list = ['age','campaign','pdays','previous','emp.var.rate',
            'cons.price.idx','cons.conf.idx'  ,
            'euribor3m','nr.employed']
num_data = data_0[num_list]
char_data = data_0.drop(num_list + ['y'],axis = 1)
data_y = data_0['y']
# 描述性统计
num_data.describe()
# 数值数据进行 标准化采用极差的标准化方式，把数据控制在0，1之内
data_x = pd.DataFrame()
min_max_scaler = preprocessing.MinMaxScaler()
num_data_scaler = pd.DataFrame(min_max_scaler.fit_transform(num_data), columns=num_data.keys())
data_x = num_data_scaler
# 字符型数据进行哑变量处理
for key in char_data.keys():
    data_x = pd.concat([data_x, pd.get_dummies(char_data[key]).iloc[:, :-1]], axis=1)

# 进行建模分析

# 数据分组
train_x, test_x, train_y, test_y = cross_validation.train_test_split(data_x, data_y, test_size=0.2)

dic_0 = {}
# 拟合模型

# logit模型
logit_model = LogisticRegression()
model = logit_model
model.fit(train_x, train_y)
begin_time = time.time()
predict_y = model.predict(test_x)
score = cross_validation.cross_val_score(model, data_x,
    data_y, cv=10, scoring='accuracy')
end_time = time.time()
print classification_report(predict_y ,test_y)
print score.mean()
dic_0['logit'] = [score.mean(), end_time - begin_time]

# knn模型
knn_model = neighbors.KNeighborsClassifier(n_neighbors = 10,weights='uniform')
model = knn_model
model.fit(train_x, train_y)
begin_time = time.time()
predict_y = model.predict(test_x)
score = cross_validation.cross_val_score(model, data_x,
    data_y, cv=10, scoring='accuracy')
end_time = time.time()

print classification_report(predict_y ,test_y)
print score.mean()
dic_0['knn'] = [score.mean(), end_time - begin_time]

# svm模型
svm_model = svm.SVC(kernel='rbf')
model = svm_model
model.fit(train_x, train_y)
begin_time = time.time()
predict_y = model.predict(test_x)
score = cross_validation.cross_val_score(model, data_x,
    data_y, cv=10, scoring='accuracy')
end_time = time.time()

print classification_report(predict_y ,test_y)
print score.mean()
dic_0['svm'] = [score.mean(), end_time - begin_time]

